Subject: Re: [core] Fwd: New Version Notification for draft-shelby-core-interfaces-01.txt

From: "Kovatsch Matthias" <[email-masked]>
Date: Wed, 1 Feb 2012 15:52:15 +0000

Dear Zach, dear list

A great advantage of the RESTful interfaces of the Web is that they are, in most cases, human-readable. It makes APIs easy to understand, thus they are learned quickly and system integration becomes cheap.

In CoAP, we can have the same benefits thanks to the textual identifiers like URIs and the link format. Especially in this draft (but also others), however, I see that mostly cryptic letters are used as identifiers to "save some bytes." I think, this combines the disadvantages of both worlds: It is unreadable like binary protocols, but still requires more bits to represent the information. Another aspect: if a letter is already taken, a confusing substitute has to be found and the benefits become even smaller.

In my opinion, we should spend additional bytes for readability wherever possible. The link-format, for instance, must be transferred block-wise anyway. Maybe a compressed SensorML with readable keys is also preferable over an cryptic JSON bastard. I just fear that CoAP could lose its advantage over other (probably binary) protocols if we drop the advantages that made the Web successful.

What is your opinion on that?

Best regards
Matthias

> -----Original Message-----
> From: [email-masked] [mailto:[email-masked]] On Behalf Of
> Zach Shelby
> Sent: Dienstag, 31. Januar 2012 15:05
> To: [email-masked] WG
> Subject: [core] Fwd: New Version Notification for draft-shelby-core-
> interfaces-01.txt
> 
> A new version of the CoRE Interfaces draft is available:
> 
> http://www.ietf.org/id/draft-shelby-core-interfaces-01.txt
> 
> New features added to this version, thanks to Cedric, Daniel and others who
> have given improvement ideas:
> 
> - Read-only Parameters
> - Toggle feature on Actuators using POST
> - Defined use of Observation and new period/step query string parameters
> 
> Zach
> 
> Begin forwarded message:
> 
> > From: [email-masked]
> > Date: January 31, 2012 4:00:34 PM GMT+02:00
> > To: [email-masked]
> > Cc: [email-masked]
> > Subject: New Version Notification for draft-shelby-core-interfaces-01.txt
> >
> > A new version of I-D, draft-shelby-core-interfaces-01.txt has been
> successfully submitted by Zach Shelby and posted to the IETF repository.
> >
> > Filename:	 draft-shelby-core-interfaces
> > Revision:	 01
> > Title:		 CoRE Interfaces
> > Creation date:	 2012-01-31
> > WG ID:		 Individual Submission
> > Number of pages: 13
> >
> > Abstract:
> >   This document defines well-known REST interface descriptions for
> >   Batch, Sensor, Parameter and Actuator types for use in contrained web
> >   servers using the CoRE Link Format.  A short reference is provided
> >   for each type that can be efficiently included in the interface
> >   description attribute of the CoRE Link Format.  These descriptions
> >   are intended to be for general use in resource designs or for
> >   inclusion in more specific interface profiles.
> >
> >
> >
> >
> > The IETF Secretariat
> 
> --
> Zach Shelby, Chief Nerd, Sensinode Ltd.
> http://www.sensinode.com
> http://zachshelby.org  - My blog "On the Internet of Things"
> http://6lowpan.net - My book "6LoWPAN: The Wireless Embedded Internet"
> Mobile: +358 40 7796297
> 
> _______________________________________________
> core mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/core